Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class DoubleValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.NumericValue
                  net.sf.saxon.value.DoubleValue

All Implemented Interfaces:
  Serializable, Comparable, SequenceIterable, Item, ValueRepresentation

    public final class DoubleValue

extends NumericValue

A numeric (double precision floating point) value

See Also:
  Serialized Form

Field Summary
`static DoubleValue` | `NaN`
`static DoubleValue` | `NEGATIVE_ZERO`
`static DoubleValue` | `ONE`
`static DoubleValue` | `ZERO`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY, INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`DoubleValue(CharSequence val)` Constructor supplying a string
`DoubleValue(double value)` Constructor supplying a double
`DoubleValue(double value, AtomicType type)` Constructor supplying a double and an AtomicType, for creating a value that belongs to a user-defined subtype of xs:double.

Method Summary
`NumericValue` | `arithmetic(int operator, NumericValue other, XPathContext context)` Evaluate a binary arithmetic operator.
`NumericValue` | `ceiling()` Implement the XPath ceiling() function
`int` | `compareTo(long other)` Compare the value to a long.
`AtomicValue` | `convertPrimitive(BuiltInAtomicType requiredType, boolean validate, XPathContext context)` Convert to target data type
`Object` | `convertToJava(Class target, XPathContext context)` Convert to Java object (for passing to external functions)
`AtomicValue` | `copy(AtomicType typeLabel)` Create a copy of this atomic value, with a different type label
`static CharSequence` | `doubleToString(double value)` Internal method used for conversion of a double to a string
`static CharSequence` | `doubleToStringOLD(double value, String javaString)` Internal method used for conversion of a double to a string
`boolean` | `effectiveBooleanValue()` Get the effective boolean value
`NumericValue` | `floor()` Implement the XPath floor() function
`CharSequence` | `getCanonicalLexicalRepresentation()` Get the canonical lexical representation as defined in XML Schema.
`double` | `getDoubleValue()` Return this numeric value as a double
`BuiltInAtomicType` | `getPrimitiveType()` Determine the primitive type of the value.
`Comparable` | `getSchemaComparable()` Get an object that implements XML Schema comparison semantics
`String` | `getStringValue()` Convert the double to a string according to the XPath 2.0 rules
`CharSequence` | `getStringValueCS()` Convert the double to a string according to the XPath 2.0 rules
`int` | `hashCode()` Get the hashCode.
`boolean` | `isNaN()` Test whether the value is the double/float value NaN
`boolean` | `isWholeNumber()` Determine whether the value is a whole number, that is, whether it compares equal to some integer
`NumericValue` | `negate()` Negate the value
`static void` | `printInternalForm(double d)` Diagnostic method
`NumericValue` | `round()` Implement the XPath round() function
`NumericValue` | `roundHalfToEven(int scale)` Implement the XPath round-to-half-even() function
`double` | `signum()` Determine whether the value is negative, zero, or positive

Methods inherited from class net.sf.saxon.value.NumericValue
`compareTo, equals, getDecimalValue, getFloatValue, getXPathComparable, isInteger, longValue, parseNumber, promote, toString`

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, getCardinality, getComponent, getItemType, getLength, getTypedValue, getTypeLabel, hasBuiltInType, isMultiValued, itemAt, iterate, process, setTypeLabel`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, convert, convertJavaObjectToXPath, fromItem, getIterator, iterate, makeQNameValue, reduce, stringToNumber`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### ZERO

    public static final DoubleValue ZERO

### NEGATIVE_ZERO

    public static final DoubleValue NEGATIVE_ZERO

### ONE

    public static final DoubleValue ONE

### NaN

    public static final DoubleValue NaN

Constructor Detail

### DoubleValue

    public DoubleValue(CharSequence val)
                throws ValidationException

  Constructor supplying a string

  Throws:
    `ValidationException` - if the string does not have the correct lexical form for a double. Note that the error will contain no error code or context information.

### DoubleValue

    public DoubleValue(double value)

  Constructor supplying a double

  Parameters:
    `value` - the value of the NumericValue

### DoubleValue

    public DoubleValue(double value,
                       AtomicType type)

  Constructor supplying a double and an AtomicType, for creating a value that belongs to a user-defined subtype of xs:double. It is the caller's responsibility to ensure that the supplied value conforms to the supplied type.

  Parameters:
    `value` - the value of the NumericValue
    `type` - the type of the value. This must be a subtype of xs:double, and the value must conform to this type. The methosd does not check these conditions.

Method Detail

### copy

    public AtomicValue copy(AtomicType typeLabel)

  Create a copy of this atomic value, with a different type label

  Specified by:
    `copy` in class `AtomicValue`
  Parameters:
    `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.

### getPrimitiveType

    public BuiltInAtomicType getPrimitiveType()

  Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.

  Specified by:
    `getPrimitiveType` in class `AtomicValue`

### getDoubleValue

    public double getDoubleValue()

  Return this numeric value as a double

  Overrides:
    `getDoubleValue` in class `NumericValue`
  Returns:
    the value as a double

### hashCode

    public int hashCode()

  Get the hashCode. This must conform to the rules for other NumericValue hashcodes

  Specified by:
    `hashCode` in class `NumericValue`
  Returns:
    the hash code of the numeric value
  See Also:
    `NumericValue.hashCode()`

### isNaN

    public boolean isNaN()

  Test whether the value is the double/float value NaN

  Overrides:
    `isNaN` in class `NumericValue`

### effectiveBooleanValue

    public boolean effectiveBooleanValue()

  Get the effective boolean value

  Overrides:
    `effectiveBooleanValue` in class `AtomicValue`
  Returns:
    the effective boolean value (true unless the value is zero or NaN)

### convertPrimitive

    public AtomicValue convertPrimitive(BuiltInAtomicType requiredType,
                                        boolean validate,
                                        XPathContext context)

  Convert to target data type

  Specified by:
    `convertPrimitive` in class `AtomicValue`
  Parameters:
    `requiredType` - an integer identifying the required atomic type
    `context` -
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
  Returns:
    an AtomicValue, a value of the required type

### getStringValue

    public String getStringValue()

  Convert the double to a string according to the XPath 2.0 rules

  Specified by:
    `getStringValue` in interface `Item`
  Specified by:
    `getStringValue` in interface `ValueRepresentation`
  Specified by:
    `getStringValue` in class `AtomicValue`
  Returns:
    the string value
  See Also:
    `Item.getStringValueCS()`

### getStringValueCS

    public CharSequence getStringValueCS()

  Convert the double to a string according to the XPath 2.0 rules

  Specified by:
    `getStringValueCS` in interface `Item`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation`
  Overrides:
    `getStringValueCS` in class `AtomicValue`
  Returns:
    the string value
  See Also:
    `Item.getStringValue()`

### getCanonicalLexicalRepresentation

    public CharSequence getCanonicalLexicalRepresentation()

  Get the canonical lexical representation as defined in XML Schema. This is not always the same as the result of casting to a string according to the XPath rules. For xs:double, the canonical representation always uses exponential notation.

  Overrides:
    `getCanonicalLexicalRepresentation` in class `Value`

### doubleToString

    public static CharSequence doubleToString(double value)

  Internal method used for conversion of a double to a string

  Parameters:
    `value` - the actual value
  Returns:
    the value converted to a string, according to the XPath casting rules.

### doubleToStringOLD

    public static CharSequence doubleToStringOLD(double value,
                                                 String javaString)

  Internal method used for conversion of a double to a string

  Parameters:
    `value` - the actual value
    `javaString` - the result of converting the double to a string using the Java conventions. This value is adjusted as necessary to cater for the differences between the Java and XPath rules.
  Returns:
    the value converted to a string, according to the XPath casting rules.

### negate

    public NumericValue negate()

  Negate the value

  Specified by:
    `negate` in class `NumericValue`
  Returns:
    a value, of the same type as the original, with its sign inverted

### floor

    public NumericValue floor()

  Implement the XPath floor() function

  Specified by:
    `floor` in class `NumericValue`
  Returns:
    a value, of the same type as that supplied, rounded towards minus infinity

### ceiling

    public NumericValue ceiling()

  Implement the XPath ceiling() function

  Specified by:
    `ceiling` in class `NumericValue`
  Returns:
    a value, of the same type as that supplied, rounded towards plus infinity

### round

    public NumericValue round()

  Implement the XPath round() function

  Specified by:
    `round` in class `NumericValue`
  Returns:
    a value, of the same type as that supplied, rounded towards the nearest whole number (0.5 rounded up)

### roundHalfToEven

    public NumericValue roundHalfToEven(int scale)

  Implement the XPath round-to-half-even() function

  Specified by:
    `roundHalfToEven` in class `NumericValue`
  Parameters:
    `scale` - the decimal position for rounding: e.g. 2 rounds to a multiple of 0.01, while -2 rounds to a multiple of 100
  Returns:
    a value, of the same type as the original, rounded towards the nearest multiple of 10**(-scale), with rounding towards the nearest even number if two values are equally near

### signum

    public double signum()

  Determine whether the value is negative, zero, or positive

  Specified by:
    `signum` in class `NumericValue`
  Returns:
    -1 if negative, 0 if zero (including negative zero), +1 if positive, NaN if NaN

### isWholeNumber

    public boolean isWholeNumber()

  Determine whether the value is a whole number, that is, whether it compares equal to some integer

  Specified by:
    `isWholeNumber` in class `NumericValue`
  Returns:
    true if the value is a whole number

### arithmetic

    public NumericValue arithmetic(int operator,
                                   NumericValue other,
                                   XPathContext context)
                            throws XPathException

  Evaluate a binary arithmetic operator.

  Specified by:
    `arithmetic` in class `NumericValue`
  Parameters:
    `operator` - the binary arithmetic operation to be performed. Uses the constants defined in the Token class, for example `Token.PLUS`, `Token.MINUS`
    `other` - the second operand
  Returns:
    the result of the arithmetic operation
  Throws:
    `XPathException` - if an arithmetic error occurs
  See Also:
    `Tokenizer`

### compareTo

    public int compareTo(long other)

  Compare the value to a long.

  Specified by:
    `compareTo` in class `NumericValue`
  Parameters:
    `other` - the value to be compared with
  Returns:
    -1 if this is less, 0 if this is equal, +1 if this is greater or if this is NaN

### getSchemaComparable

    public Comparable getSchemaComparable()

  Get an object that implements XML Schema comparison semantics

  Overrides:
    `getSchemaComparable` in class `Value`

### convertToJava

    public Object convertToJava(Class target,
                                XPathContext context)
                         throws XPathException

  Convert to Java object (for passing to external functions)

  Overrides:
    `convertToJava` in class `Value`
  Throws:
    `XPathException`

### printInternalForm

    public static void printInternalForm(double d)

  Diagnostic method

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.